#!/usr/bin/perl

#-------------------------------------------------------------------------------------#
#       $input_string  $ENV{'CONTENT_LENGTH'}
read (STDIN, $input_string, $ENV{'CONTENT_LENGTH'});

#      
@input_pairS = split "&", $input_string;
#       
foreach $input_pair (@input_pairS)
 {
  #   -  
  ($name, $value) = split "=", $input_pair;
  $FORM{$name} = $value;
  #   -  
  ($key, $content) = split "=", $input_pair, 2;
  #     
  $content =~ s/\+/ /g;
  #  
  $content =~ s/%([a-fA-F--0-9][a-fA-F--0-9])/pack "C", hex($1)/eg;
  #    
  $content =~ s/\r//g;
  $FORM{$key} = $content;
 }
#-------------------------------------------------------------------------------------#

#-----------------------------------------------------------------------#
#  : 
#-----------------------------------------------------------------------#
my $stat_info;

#  
my $file_size;
#  
my $file_type;
#  
my $file_version;

my $file_content;
my $full_stat_info;
#-----------------------------------------------------------------------#
#  : 
#-----------------------------------------------------------------------#

print "content-type: text/html; charset=Windows-1251\n\n";
#print "  ", $ENV{'CONTENT_LENGTH'}, " <br>";
#print $input_string."<br>";

if(!-r $FORM{'file_path'})
 {
  $stat_info .= (":  ".$FORM{'file_path'}."       !<br>");
  exit;
 };
#  ,  
open FILE,$FORM{'file_path'}; binmode FILE;
#     ( )
(undef, undef, undef, undef, undef, undef, undef, $file_size) = stat FILE;
#      
seek FILE,0,0; read FILE,$file_content,$file_size;
#     
seek FILE,0,0; read FILE,$file_type,4;
seek FILE,4,0; read FILE,$file_version,4;
#  
close FILE;

#       
$file_type =~ s/ //g;
$file_version =~ s/ //g;

#   
$file_content =~ s/\r//g;

#  
$file_content =~ s/\x09/ /g;

#    
my @file_strings_array = split "\n", $file_content;

#    
my $file_options = @file_strings_array[1];

#  
my $oputput_content;

#  
my @header_items = split / {1,}/, @file_strings_array[2];

#  
my $output_header = "<tr style='background-color: #808080; color: white;'>";
for my $header_item_number (0..$#header_items)
 {
  if($header_item_number == 0){ $output_header .= ("<td>".@header_items[$header_item_number]."</td>"); }
  else{ $output_header .= ("<td id='2_".$header_item_number."' title=': ".@header_items[$header_item_number].".' onClick='cell_edit(this); return false;'>".@header_items[$header_item_number]."</td>"); }
 }
$output_header .= "</tr>";

#   
my $max_column_numbers = 0;

for my $tr_number (3..$#file_strings_array)
 {
  my @td_items = split / {1,}/, @file_strings_array[$tr_number];
  my $td_joined;
  if($#td_items > $max_column_numbers){ $max_column_numbers = $#td_items + 1; };
  for my $td_number (0..$#td_items)
   {
    if($td_number ne 0)
     {
      my $td_parameters = "title=': ".((@td_items[0] =~ /[^\d]{1,}/) ? @td_items[0] : @td_items[1]).", : @header_items[$td_number].' onMouseOver='title_over(this); cell_over(this);' onMouseOut='title_out(this); cell_out(this);' onClick='cell_edit(this); return false;'";
      $td_joined .= ("<td id='".$tr_number."_".$td_number."' ".$td_parameters.">".@td_items[$td_number]."</td>");
     }
    else{ $td_joined .= ("<td id='".$tr_number."_".$td_number."' class='cell'".$td_parameters." title=': ".@td_items[$td_number].".' onClick='cell_edit(this); return false;'>".@td_items[$td_number]."</td>"); }
   }
  $current_string = "<tr>".$td_joined."</tr>";
  $oputput_content .= $current_string;
 }

#      
print <<HTML;
<script type='text/javascript'><!--
parent.document.getElementById("file_content").innerHTML = "<form name='main_form' style='margin: 0px; padding: 0px;'><table cellspacing='1px' style='margin: 0px; padding: 0px; font: normal 10px verdana;'><tbody>$output_header$oputput_content</tbody></table></form>";

parent.document.main_form.load_2da.title = parent.document.main_form.load_2da.value;

parent.content_dimension();

parent.document.getElementById("file_info").innerHTML = "<nobr>: $file_size , : $file_type, : $file_version, : $file_options, : $#file_strings_array, : $max_column_numbers</nobr>";

//parent.max_string_numbers = "$#file_strings_array";
//parent.max_column_numbers = "$max_column_numbers";

//parent.cell_edit(parent.document.getElementById("3_1"));

parent.FLAG_no_action = 0;
parent.document.open_file_form.reset();
// --></script>
HTML
