#!/usr/bin/perl

#-------------------------------------------------------------------------------------#
#  :   
#-------------------------------------------------------------------------------------#
#       $input_string  $ENV{'CONTENT_LENGTH'}
read (STDIN, $input_string, $ENV{'CONTENT_LENGTH'});
#      
@input_pairS = split "&", $input_string;
#       
foreach $input_pair (@input_pairS)
 {
  #   -  
  ($name, $value) = split "=", $input_pair;
  $FORM{$name} = $value;
  #   -  
  ($key, $content) = split "=", $input_pair, 2;
  #     
  $content =~ s/\+/ /g;
  #  
  $content =~ s/%([a-fA-F--0-9][a-fA-F--0-9])/pack "C", hex($1)/eg;
  #    
  $content =~ s/\r//g;
  $FORM{$key} = $content;
 }
#-------------------------------------------------------------------------------------#
#  :   
#-----------------------------------------------------------------------#
#  : 
#-----------------------------------------------------------------------#
my $stat_info;

#  
my $file_size;
#  
my $file_type;
#  
my $file_version;

my $file_content;
my $full_stat_info;
#-----------------------------------------------------------------------#
#  : 
#-----------------------------------------------------------------------#
#  : 
#-----------------------------------------------------------------------#
sub get_WORD
 { return unpack "v", (substr $_[0],$_[1],4); }

sub get_DWORD
 { return unpack "V", (substr $_[0],$_[1],4); }

sub get_WORD_symbols
 { return pack "v", $_[0]; }

sub get_DWORD_symbols
 { return pack "V", $_[0]; }

sub read_block
 {
  if(!-r $FORM{'tlk_file_path'})
   { $stat_info .= (":  ".$FORM{'tlk_file_path'}."       !<br>"); exit; };
  open FILE,$FORM{'tlk_file_path'}; binmode FILE;
  seek FILE,$_[0],0; read FILE,$_[2],$_[1];
  close FILE;
 }

sub get_String_Content
 {
  if($tlk_file_version eq "V3.0")
   { #   
     my $tlk_current_offset = get_DWORD($tlk_strings_data_table,$tlk_string_data_length*$_[0]+28);
     #   
     my $tlk_current_length = get_DWORD($tlk_strings_data_table,$tlk_string_data_length*$_[0]+32);
     #   
     return (substr $tlk_strings_content,$tlk_current_offset,$tlk_current_length); }
  elsif($tlk_file_version eq "V1  ")
   { my $tlk_current_offset = get_DWORD($tlk_strings_data_table,$tlk_string_data_length*$_[0]+18);
     my $tlk_current_length = get_DWORD($tlk_strings_data_table,$tlk_string_data_length*$_[0]+22);
     return (substr $tlk_strings_content,$tlk_current_offset,$tlk_current_length); }
 }
#-----------------------------------------------------------------------#
#  : 
#-----------------------------------------------------------------------#
print "content-type: text/html; charset=Windows-1251\n\n";
#print "  ", $ENV{'CONTENT_LENGTH'}, " <br>";
print $input_string."<br>";

if(!-r $FORM{'itm_file_path'})
 { $stat_info .= (":  ".$FORM{'itm_file_path'}."       !<br>"); exit; };
#  ,  
open FILE,$FORM{'itm_file_path'}; binmode FILE;
#     ( )
(undef, undef, undef, undef, undef, undef, undef, $file_size) = stat FILE;
#      
seek FILE,0,0; read FILE,$file_content,$file_size;
#     
seek FILE,0,0; read FILE,$file_type,4;
seek FILE,4,0; read FILE,$file_version,4;
#  
close FILE;

#       
$file_type =~ s/ //g;
$file_version =~ s/ //g;

#  
my $strref_count = 0;

#   ()
my $Item_Name_Generic = get_DWORD(substr $file_content,8,4);
   if($Item_Name_Generic eq 9999999 ||$Item_Name_Generic eq 4294967295)
    { $Item_Name_Generic = ""; }else{ $strref_count++; };
my $Item_Name_Generic_Content = " ";
#   ()
my $Item_Name_Identified = get_DWORD(substr $file_content,12,4);
   if($Item_Name_Identified eq 9999999 || $Item_Name_Identified eq 4294967295)
    { $Item_Name_Identified = ""; }else{ $strref_count++; };
my $Item_Name_Identified_Content = " ";
#  
my $Used_Up_Item = (substr $file_content,16,8); $Used_Up_Item =~ s/\W//g;
#  ( 13 )
my $Flags = unpack "b13", (substr $file_content,24,4);
#    
my $Item_category_index = get_WORD(substr $file_content,28,2);
#    ( 32 )
my $Item_usability = unpack "b32", (substr $file_content,30,4);
#   BAM-   
my $inventory_portrait_BAM_resource_index = (substr $file_content,34,2);
   $inventory_portrait_BAM_resource_index =~ s/\W//g;
#      40
my $Minimum_level = ((0 < get_WORD(substr $file_content,36,2)) && (get_WORD(substr $file_content,36,2) < 40)) ? get_WORD(substr $file_content,36,2) : 0;
#      25
my $Minimum_strength = ((0 < get_WORD(substr $file_content,38,2)) && (get_WORD(substr $file_content,38,2) < 25)) ? get_WORD(substr $file_content,38,2) : 0;
#       99
my $Minimum_strength_bonus = ((0 < get_WORD(substr $file_content,40,2)) && (get_WORD(substr $file_content,40,2) < 99)) ? get_WORD(substr $file_content,40,2) : 0;
#      25
my $Minimum_intelligence = ((0 < get_WORD(substr $file_content,42,2)) && (get_WORD(substr $file_content,42,2) < 25)) ? get_WORD(substr $file_content,42,2) : 0;
#      25
my $Minimum_dexterity = ((0 < get_WORD(substr $file_content,44,2)) && (get_WORD(substr $file_content,44,2) < 25)) ? get_WORD(substr $file_content,44,2) : 0;
#      25
my $Minimum_wisdom = ((0 < get_WORD(substr $file_content,46,2)) && (get_WORD(substr $file_content,46,2) < 25)) ? get_WORD(substr $file_content,46,2) : 0;
#      25
my $Minimum_constitution = ((0 < get_WORD(substr $file_content,48,2)) && (get_WORD(substr $file_content,48,2) < 25)) ? get_WORD(substr $file_content,48,2) : 0;
#      25
my $Minimum_charisma = ((0 < get_WORD(substr $file_content,50,2)) && (get_WORD(substr $file_content,50,2) < 25)) ? get_WORD(substr $file_content,50,2) : 0;
#  
my $Base_value = get_DWORD(substr $file_content,52,4);
#   
my $Max_stackable = get_WORD(substr $file_content,56,2);
#  
my $Item_Icon = (substr $file_content,58,8); $Item_Icon =~ s/\W//g;
#    
my $Lore = get_WORD(substr $file_content,66,2);
#  ,   
my $Ground_Icon = (substr $file_content,68,8); $Ground_Icon =~ s/\W//g;
#  
my $Base_weight = get_DWORD(substr $file_content,76,4);
#   ()
my $Item_Description_Generic = get_DWORD(substr $file_content,80,4);
   if($Item_Description_Generic eq 9999999 || $Item_Description_Generic eq 4294967295)
    { $Item_Description_Generic = ""; }else{ $strref_count++; };
my $Item_Description_Generic_Content = " ";
#   ()
my $Item_Description_Identified = get_DWORD(substr $file_content,84,4);
   if($Item_Description_Identified eq 9999999 || $Item_Description_Identified eq 4294967295)
    { $Item_Description_Identified = ""; }else{ $strref_count++; };
my $Item_Description_Identified_Content = " ";
#   
my $Carried_Icon = (substr $file_content,88,8); $Carried_Icon =~ s/\W//g;
# ""
my $Enchantment = get_DWORD(substr $file_content,96,4);

#  tlk-
if($FORM{'tlk_file_path'} ne "")
 {
  if(!-r $FORM{'tlk_file_path'})
   { $stat_info .= (":  ".$FORM{'tlk_file_path'}."       !<br>"); exit; }
  else
   { open FILE,$FORM{'tlk_file_path'};
     #     ( )
     (undef, undef, undef, undef, undef, undef, undef, $tlk_file_size) = stat FILE;
     #  
     close FILE; }

  read_block(0,20,$tlk_header);
  #   
  $tlk_file_type = substr $tlk_header,0,4;
  if($tlk_file_type ne "TLK ")
   { $stat_info .= (":   ".$FORM{'tlk_file_path'}."  !<br>"); exit; };
  #  
  $tlk_file_version = substr $tlk_header,4,4;
  if($tlk_file_version eq "V3.0")
   { #     
     $tlk_file_strings = (get_DWORD($tlk_header,12) - 1);
     #        
     $tlk_strings_offset = get_DWORD($tlk_header,16); }
  elsif($tlk_file_version eq "V1  ")
   { $tlk_file_strings = (get_DWORD($tlk_header,10) - 1);
     $tlk_strings_offset = get_DWORD($tlk_header,14); }

  if($tlk_file_version eq "V3.0")
   { $tlk_header_length = 20; $tlk_string_data_length = 40; }
  elsif($tlk_file_version eq "V1  ")
   { $tlk_header_length = 18; $tlk_string_data_length = 26; }

  read_block($tlk_header_length,$tlk_strings_offset-$tlk_header_length,$tlk_strings_data_table);
  read_block($tlk_strings_offset,$tlk_file_size-$tlk_strings_offset,$tlk_strings_content);

  if($Item_Name_Generic ne "")
   { $Item_Name_Generic_Content = get_String_Content($Item_Name_Generic);
     #   (5c),   (0a  0d)   (22)  
     $Item_Name_Generic_Content =~ s/\x5c/\\x5c/g;
     $Item_Name_Generic_Content =~ s/\x0a/\\x0a/g;
     $Item_Name_Generic_Content =~ s/\x0d/\\x0d/g;
     $Item_Name_Generic_Content =~ s/\x22/\\x22/g; };
  if($Item_Name_Identified ne "")
   { $Item_Name_Identified_Content = get_String_Content($Item_Name_Identified);
     #   (5c),   (0a  0d)   (22)  
     $Item_Name_Identified_Content =~ s/\x5c/\\x5c/g;
     $Item_Name_Identified_Content =~ s/\x0a/\\x0a/g;
     $Item_Name_Identified_Content =~ s/\x0d/\\x0d/g;
     $Item_Name_Identified_Content =~ s/\x22/\\x22/g; };
  if($Item_Description_Generic ne "")
   { $Item_Description_Generic_Content = get_String_Content($Item_Description_Generic);
     #   (5c),   (0a  0d)   (22)  
     $Item_Description_Generic_Content =~ s/\x5c/\\x5c/g;
     $Item_Description_Generic_Content =~ s/\x0a/\\x0a/g;
     $Item_Description_Generic_Content =~ s/\x0d/\\x0d/g;
     $Item_Description_Generic_Content =~ s/\x22/\\x22/g; };
  if($Item_Description_Identified ne "")
   { $Item_Description_Identified_Content = get_String_Content($Item_Description_Identified);
     #   (5c),   (0a  0d)   (22)  
     $Item_Description_Identified_Content =~ s/\x5c/\\x5c/g;
     $Item_Description_Identified_Content =~ s/\x0a/\\x0a/g;
     $Item_Description_Identified_Content =~ s/\x0d/\\x0d/g;
     $Item_Description_Identified_Content =~ s/\x22/\\x22/g; };

 };

#      
print <<HTML;
<script type='text/javascript'><!--
parent.document.getElementById("file_info").innerHTML = "<nobr>: $file_size , : $file_type, : $file_version,  : $strref_count</nobr>";

parent.document.main_form.load_itm.title = parent.document.main_form.load_itm.value;

parent.document.main_form.Item_Name_Generic.value = "$Item_Name_Generic";
parent.document.main_form.Item_Name_Generic.readonly = false;
parent.document.main_form.Item_Name_Generic_Content.value = "$Item_Name_Generic_Content";

parent.document.main_form.Item_Name_Identified.value = "$Item_Name_Identified";
parent.document.main_form.Item_Name_Identified.readonly = false;
parent.document.main_form.Item_Name_Identified_Content.value = "$Item_Name_Identified_Content";

parent.document.main_form.Item_Description_Generic.value = "$Item_Description_Generic";
parent.document.main_form.Item_Description_Generic.readonly = false;
parent.document.main_form.Item_Description_Generic_Content.value = "$Item_Description_Generic_Content";

parent.document.main_form.Item_Description_Identified.value = "$Item_Description_Identified";
parent.document.main_form.Item_Description_Identified.readonly = false;
parent.document.main_form.Item_Description_Identified_Content.value = "$Item_Description_Identified_Content";

parent.document.main_form.Item_category_index["$Item_category_index"].selected = true;
parent.document.getElementById("Item_category_value").innerHTML = "$Item_category_index";

parent.document.main_form.Used_Up_Item.value = "$Used_Up_Item";
parent.document.main_form.Used_Up_Item.readonly = false;

parent.document.main_form.inventory_portrait_BAM_resource_index.value = "$inventory_portrait_BAM_resource_index";
parent.document.main_form.inventory_portrait_BAM_resource_index.readonly = false;

parent.document.main_form.Item_Icon.value = "$Item_Icon";
parent.document.main_form.Item_Icon.readonly = false;

parent.document.main_form.Ground_Icon.value = "$Ground_Icon";
parent.document.main_form.Ground_Icon.readonly = false;

parent.document.main_form.Carried_Icon.value = "$Carried_Icon";
parent.document.main_form.Carried_Icon.readonly = false;

function get_Bit(_string,_bit){ return _string.charAt(_bit); }
for(var bn = 0; bn < 13; bn++)
 { if(get_Bit("$Flags",bn) == 0)
    { parent.document.main_form.eval("Flags_"+bn).disabled = false;
      parent.document.main_form.eval("Flags_"+bn).checked = false; }
   else if(get_Bit("$Flags",bn) == 1)
    { parent.document.main_form.eval("Flags_"+bn).disabled = false;
      parent.document.main_form.eval("Flags_"+bn).checked = true; }
   else
    { parent.document.main_form.eval("Flags_"+bn).disabled = true; }
 }

parent.document.main_form.Base_value.value = "$Base_value";
parent.document.main_form.Base_value.readonly = false;

parent.document.main_form.Base_weight.value = "$Base_weight";
parent.document.main_form.Base_weight.readonly = false;

parent.document.main_form.Max_stackable.value = "$Max_stackable";
parent.document.main_form.Max_stackable.readonly = false;

parent.document.main_form.Lore.value = "$Lore";
parent.document.main_form.Lore.readonly = false;

parent.document.main_form.Enchantment.value = ("$Enchantment" == 0) ? "" : "+$Enchantment";
parent.document.main_form.Enchantment.readonly = false;

for(var bn = 0; bn < 31; bn++)
 { if(get_Bit("$Item_usability",bn) == 0)
    { parent.document.main_form.eval("Item_usability_"+bn).disabled = false;
      parent.document.main_form.eval("Item_usability_"+bn).checked = false; }
   else if(get_Bit("$Item_usability",bn) == 1)
    { parent.document.main_form.eval("Item_usability_"+bn).disabled = false;
      parent.document.main_form.eval("Item_usability_"+bn).checked = true; }
   else
    { parent.document.main_form.eval("Item_usability_"+bn).disabled = true; }
 }

parent.document.main_form.Minimum_level.value = "$Minimum_level";
parent.document.main_form.Minimum_level.readonly = false;

parent.document.main_form.Minimum_strength.value = "$Minimum_strength";
parent.document.main_form.Minimum_strength.readonly = false;

parent.document.main_form.Minimum_strength_bonus.value = "$Minimum_strength_bonus";
parent.document.main_form.Minimum_strength_bonus.readonly = false;

parent.document.main_form.Minimum_intelligence.value = "$Minimum_intelligence";
parent.document.main_form.Minimum_intelligence.readonly = false;

parent.document.main_form.Minimum_dexterity.value = "$Minimum_dexterity";
parent.document.main_form.Minimum_dexterity.readonly = false;

parent.document.main_form.Minimum_wisdom.value = "$Minimum_wisdom";
parent.document.main_form.Minimum_wisdom.readonly = false;

parent.document.main_form.Minimum_constitution.value = "$Minimum_constitution";
parent.document.main_form.Minimum_constitution.readonly = false;

parent.document.main_form.Minimum_charisma.value = "$Minimum_charisma";
parent.document.main_form.Minimum_charisma.readonly = false;

parent.FLAG_no_action = 0;
parent.document.open_file_form.reset();
// --></script>
HTML
